/****************************
Ajaxdo - ajax persistent data object framwork
see example folder of this release do example of use 
copyright 2006 Amir Shevat (spacebug open source initiative)
******************************/


/****************************

public methods and members

******************************/

/**
* The appContext is the name of the DB table where the 
* server side saves the javascript objects 
**/
function Ajaxdo(appContext){
	/**
	update the parameters globally here or set them at run time (e.g. ajaxdo.loadURL =...)
	**/
	this.loadURL = "http://localhost/ajaxdo_php/load.php";
	this.listURL = "http://localhost/ajaxdo_php/list.php";
	this.saveURL = "http://localhost/ajaxdo_php/save.php";
	this.deleteURL = "http://localhost/ajaxdo_php/delete.php";
	// private members
	this.objectList = new Array() ;
	this.objectHolder = new Array();
	// public members and methods
	this.appContext= appContext;
	this.loadObject =loadObject;
	this.listObjects =listObjects;
	this.saveObject =saveObject;
	this.deleteObject =deleteObject;
}


/**
* use via Ajaxdo.loadObject(objectName)
* @parameter objectName is the javascript object to be loaded
**/
function loadObject(objectName){
	url =this.loadURL+"?objectName="+objectName+"&context="+this.appContext+"&bogus="+new Date().getTime();
	var request = getXmlHttpRequest();
	var respObj = this.objectHolder;
	
	f = function(request, obj) {
		
		if (request.readyState == 4) {
			
	       if (request.status == 200) {
	            var txt = request.responseText;
	            obj[0]=txt.parseJSON();
	           
	       } else {
	        
	           alert('There was a problem with the request.');
	       }
         }
    };
        
        request.onreadystatechange =function() { f(request,respObj); }; 

		request.open("GET", url, false);
		request.send(null);
         return this.objectHolder[0];
         
          
};

/**
* use via Ajaxdo.listObjects()
**/
function listObjects(){
	
	url =this.listURL+"?context="+this.appContext+"&bogus="+new Date().getTime();
	var request = getXmlHttpRequest();
	this.objectList = new Array();
	var respObjList = this.objectList;
	f = function(request,objlist ) {
		
		if (request.readyState == 4) {
			
	       if (request.status == 200) {
	            var xmldoc = request.responseXML;
	           	var root_node = xmldoc.getElementsByTagName('data').item(0);
				this.objectList= new Array();
				for(i=0; i<root_node.childNodes.length; i++){
					var objectData = root_node.childNodes.item(i);
					if(objectData.nodeType ==1){
						objectName= objectData.getAttribute('name');
						objlist[i]= objectName;
					}//if
						
				}// for
	
	           		  
	       } else {
	        
	           alert('There was a problem with the request.');
	       }
         }
    };
    
    	request.onreadystatechange =function() { f(request,respObjList); }; 
	

		request.open("GET", url, false);
		request.send(null);
         
         return this.objectList;
         
          
};


/**
* use via Ajaxdo.saveObject(objectName)
* @parameter objectName is the javascript object id
* @parameter object is the javascript object to be saved
**/
function saveObject(objectName, object){
	var objectContent=s.object(object); 
	var result= new Array();
	url =this.saveURL+"?objectName="+objectName+"&objectValue="+objectContent+"&context="+this.appContext+"&bogus="+new Date().getTime();

	var request = getXmlHttpRequest();
	
	f = function(request, result) {
		
		if (request.readyState == 4) {
			
	       if (request.status == 200) {
	            var resp = request.responseText;
	            
	           	//alert(resp); 
	           	result[0]=resp;	  
	       } else {
	        
	           alert('There was a problem with the request.');
	       }
         }
    };
    
    request.onreadystatechange =function() { f(request,result ); }; 
   	request.open("GET", url, false);
	request.send(null);

	return result[0];
	
}

/**
* use via Ajaxdo.saveObject(objectName)
* @parameter objectName is the javascript object id to be deleted
**/
function deleteObject(objectName){
	url =this.deleteURL+"?objectName="+objectName+"&context="+this.appContext+"&bogus="+new Date().getTime();
	var result= new Array();
	var request = getXmlHttpRequest();
	f = function(request, result) {
		
		if (request.readyState == 4) {
			
	       if (request.status == 200) {
	            var resp = request.responseText;
	            
	           	//alert(xmldoc); 
	           	result[0]=resp;  
	       } else {
	        
	           alert('There was a problem with the request.');
	       }
         }
    };
   	request.onreadystatechange =function() { f(request,result ); }; 
   	request.open("GET", url, false);
	request.send(null);
	return result[0];
	
}

/****************************

private methods  

******************************/


function getXmlHttpRequest()
{
	var httpRequest = null;
	
	try
	{
		httpRequest = new ActiveXObject("Msxml2.XMLHTTP");
	}
	catch (e)
	{
		try
		{
			httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
		}
		catch (e)
		{
			httpRequest = null;
		}
	}
	
	if (!httpRequest && typeof XMLHttpRequest != "undefined")
	{
		httpRequest = new XMLHttpRequest();
	}
	
	return httpRequest;
};

function postWithResp2func(url, func){
	
	var request = getXmlHttpRequest();
	
	if (!request)
		return;

	
	request.onreadystatechange =function() { func(request); }; 
	

	request.open("GET", url, false);
	request.send(null);
	
};




/*
   	slightly modified json.js
    Copyright (c) 2002 JSON.org

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

The Software shall be used for Good, not Evil.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
    
	
    
*/

    var m = {
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"' : '\\"',
            '\\': '\\\\'
        },
        s = {
            array: function (x) {
                var a = ['['], b, f, i, l = x.length, v;
                for (i = 0; i < l; i += 1) {
                    v = x[i];
                    f = s[typeof v];
                    if (f) {
                        v = f(v);
                        if (typeof v == 'string') {
                            if (b) {
                                a[a.length] = ',';
                            }
                            a[a.length] = v;
                            b = true;
                        }
                    }
                }
                a[a.length] = ']';
                return a.join('');
            },
            'boolean': function (x) {
                return String(x);
            },
            'null': function (x) {
                return "null";
            },
            number: function (x) {
                return isFinite(x) ? String(x) : 'null';
            },
            object: function (x) {
                if (x) {
                    if (x instanceof Array) {
                        return s.array(x);
                    }
                    var a = ['{'], b, f, i, v;
                    for (i in x) {
                        v = x[i];
                        f = s[typeof v];
                        if (f) {
                            v = f(v);
                            if (typeof v == 'string') {
                                if (b) {
                                    a[a.length] = ',';
                                }
                                a.push(s.string(i), ':', v);
                                b = true;
                            }
                        }
                    }
                    a[a.length] = '}';
                    return a.join('');
                }
                return 'null';
            },
            string: function (x) {
                if (/["\\\x00-\x1f]/.test(x)) {
                    x = x.replace(/([\x00-\x1f\\"])/g, function(a, b) {
                        var c = m[b];
                        if (c) {
                            return c;
                        }
                        c = b.charCodeAt();
                        return '\\u00' +
                            Math.floor(c / 16).toString(16) +
                            (c % 16).toString(16);
                    });
                }
                return '"' + x + '"';
            }
        };
	


String.prototype.parseJSON = function () {
    try {
        return !(/[^,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]/.test(
                this.replace(/"(\\.|[^"\\])*"/g, ''))) &&
            eval('(' + this + ')');
    } catch (e) {
        return false;
    }
};






